import { Component, EventEmitter, OnInit, Output } from '@angular/core';
import { FormBuilder, FormGroup, Validators } from '@angular/forms';
import { Observable } from 'rxjs';
import { Candidate } from 'src/app/shared/models/candidate';
import { CandidateService } from 'src/app/shared/services/candidate.service';

@Component({
  selector: 'app-candidat-search',
  templateUrl: './candidat-search.component.html',
  styleUrls: ['./candidat-search.component.scss']
})
export class CandidatSearchComponent implements OnInit {
  candidates: Observable<Candidate[]>;
  searchForm: FormGroup;
  @Output() public candidatsListResultEvent = new EventEmitter<Observable<Candidate[]>>();
 

  constructor(private formBuilder: FormBuilder,private candidatService: CandidateService) { }

  ngOnInit(): void {
    this.Form();
  }
  private Form() {
    this.searchForm = this.formBuilder.group({
      firstName: [""],
      lastName: [""],
      email: ["", Validators.email]
    });
  }
  
  search(){
    let FN = this.searchForm.controls['firstName'].value;
    let LN = this.searchForm.controls['lastName'].value;
    let EML = this.searchForm.controls['email'].value;
    this.candidatsListResultEvent.emit(this.candidatService.search(FN,LN,EML))
    //this.candidatService.search(FN,LN,EML).subscribe(s=> this.candidatsListResultEvent.emit(s));
  }
  
  onSubmit() {
    if (this.searchForm.invalid) {
      alert('Data Error!! :\n\n' + JSON.stringify(this.searchForm.value, null,4));
      return;
    }
    this.search()
  }
}
