import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { BehaviorSubject, Observable } from 'rxjs';
import { Candidate } from '../models/candidate';

@Injectable({
  providedIn: 'root'
})
export class CandidateService {

  private _candidatsList = new BehaviorSubject<Candidate[]>([]);
  private _candidat = new BehaviorSubject<Candidate>(new Candidate());
  readonly candidats = this._candidatsList.asObservable();
  readonly candidat = this._candidat.asObservable();
  private dataStore:  Candidate[];
  constructor(private http: HttpClient) { }
  
 candidatGetById(id: string): Observable<Candidate> {
   this.http.get<Candidate[]>('assets/demo/data/candidates.json').subscribe(
           e => { 
             var candidatById = e.filter(i => i.id == id); 
             this._candidat.next(Object.assign({}, candidatById[0]));
           });
    return this.candidat;
  }

  search(queryFN: string, queryLN: string, queryEML: string): Observable<Candidate[]> {
    this.http.get<Candidate[]>('assets/demo/data/candidates.json').subscribe(
      e => { 
        if(queryFN){
          this.dataStore = e.filter(i => i.firstName == queryFN); 
        this._candidatsList.next(Object.assign({}, this.dataStore));
        }
        if(queryLN){
          this.dataStore = e.filter(i => i.lastName == queryLN); 
        this._candidatsList.next(Object.assign({}, this.dataStore));
        }
      });
     
    return this.candidats;
  }
}
